package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;

public class RauschfilterKernel extends Kernel {
  private float[] noisy;
  private float[] clean;
  private int len;
  RauschfilterKernel(float[] noisy, float[] clean, int len) {
    this.noisy = noisy;
    this.clean = clean;
    this.len = len;
  }
  @Override
  public void run() {
    // y_i = 1/N(x_-N/2 + x_-N/2+1 + ... + x_-1 + x_0 + x_1 + ... + x_N/2-1 + x_N/2)
    int i = getGlobalId();
    float sum = 0;

    for (int n = 1; n <= len; n++) {
      // To the right of x
      if (i + n < noisy.length) {
        sum += noisy[i + n];
      }
      // To the left of x
      if (i - n >= 0) {
        sum += noisy[i - n];
      }
    }
    // write into clean
    clean[i] = (sum + noisy[i]) / len;
  }
}
